unit UfrmMain;

{$DEFINE DEBUG}
{$UNDEF DEBUG}

{$IFNDEF DEBUG}
{$O+,D-,Q-,R-}
{$ENDIF DEBUG}

{ $Revision: 1 $ }
{  $Archive: /Delphi 2.0/Projekte/CPLDemo/UfrmMain.pas $ }
{ $Workfile: UfrmMain.pas $ }
{   $Author: Cueb $ }
{     $Date: 10.08.97 13:46 $ }
{  $Modtime: 10.08.97 12:51 $ }
{  $History: UfrmMain.pas $ }
{  }
{ *****************  Version 1  ***************** }
{ User: Cueb         Date: 10.08.97   Time: 13:46 }
{ Created in $/Delphi 2.0/Projekte/CPLDemo }
{ Demo app for TControlPanelLauncher. }
{  $NoKeywords: $ }

interface

uses
	Windows,
	Classes,
	Graphics,
	Forms,
	Controls,
	Menus,
	Dialogs,
	StdCtrls,
	Buttons,
	ExtCtrls,
	ComCtrls,
	ControlPanelLauncher;

type
	TfrmMain = class(TForm)
		pnlToolbar: TPanel;
		pnlExit: TPanel;
		btnExit: TSpeedButton;
		pnlMain: TPanel;
		ControlPanelLauncher1: TControlPanelLauncher;
		lbAvailableKnownCPLs: TListBox;
    lbAvailableNamedCPLs: TListBox;
    Label1: TLabel;
    Label2: TLabel;
		procedure FormCreate(Sender: TObject);
		procedure cmdExit(Sender: TObject);
    procedure lbAvailableNamedCPLsDblClick(Sender: TObject);
    procedure lbAvailableKnownCPLsDblClick(Sender: TObject);
    procedure lbAvailableNamedCPLsClick(Sender: TObject);
    procedure lbAvailableKnownCPLsDrawItem(Control: TWinControl;
      Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure FormDestroy(Sender: TObject);
    procedure lbAvailableKnownCPLsMeasureItem(Control: TWinControl;
      Index: Integer; var Height: Integer);
	private
		{ Private declarations }
	public
		{ Public declarations }
	end;

var
	frmMain: TfrmMain;

implementation

uses
	SysUtils,
	ShellApi;
	
{$R VERSIONINFO.RES}
{$R *.DFM}

procedure TfrmMain.FormCreate(Sender: TObject);
begin
//	Application.OnHint := ShowHint;

	lbAvailableKnownCPLs.Items.Assign(ControlPanelLauncher1.CPLNameList);
	lbAvailableKnownCPLs.Items.Delete(0);
	lbAvailableNamedCPLs.Items.Assign(ControlPanelLauncher1.FriendlyNameList);
end;

procedure TfrmMain.cmdExit(Sender: TObject);
begin
	Application.MainForm.Close;
end;

procedure TfrmMain.lbAvailableNamedCPLsDblClick(Sender: TObject);
begin
	ControlPanelLauncher1.Execute;
end;

procedure TfrmMain.lbAvailableKnownCPLsDblClick(Sender: TObject);
begin
	ControlPanelLauncher1.FriendlyName	:= '';
	ControlPanelLauncher1.CPLName	:= lbAvailableKnownCPLs.Items[lbAvailableKnownCPLs.ItemIndex];
	ControlPanelLauncher1.Params	:= '';			// be aware of setting this property right
	ControlPanelLauncher1.Execute;
end;

procedure TfrmMain.lbAvailableNamedCPLsClick(Sender: TObject);
begin
	with (Sender as TListBox) do begin
		ControlPanelLauncher1.FriendlyName	:= Items[ItemIndex];
		Hint	:= ControlPanelLauncher1.Hint;
	end;
end;

procedure TfrmMain.lbAvailableKnownCPLsDrawItem(Control: TWinControl;
	Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
	gap				: Integer;
	bitmap		: TBitmap;
	icon			: TIcon;
	copyMode	: TCopyMode;
	transparentColor	: TColor;
begin
	gap								:= 2;
	copyMode					:= cmSrcCopy;
	transparentColor	:= clWindow;

	if odSelected in State then begin
		(Control as TListBox).Canvas.Brush.Color	:= clActiveCaption;
		(Control as TListBox).Canvas.Font.Color		:= clCaptionText;
		copyMode					:= cmSrcCopy;
		transparentColor	:= clActiveCaption;
		end
	else if odGrayed in State then begin
		end
	else if odDisabled in State then begin
		end
	else if odChecked in State then begin
		end
	else if odFocused in State then begin
		end
	else begin
		(Control as TListBox).Canvas.Brush.Color	:= (Control as TListBox).Color;
		(Control as TListBox).Canvas.Font.Color		:= (Control as TListBox).Font.Color;
		copyMode					:= cmSrcAnd;
		transparentColor	:= clWhite;
	end;

	// Rechteck lschen
	(Control as TListBox).Canvas.FillRect(Rect);

	// Bitmap holen
	bitmap := TBitmap((Control as TListBox).Items.Objects[Index]);
	if bitmap = nil then begin
		icon	:= TIcon.Create;
		try
			icon.Handle	:= ExtractIcon(HInstance, PChar((Control as TListBox).Items[Index]), 0);
			if icon.Handle = 0 then begin
				icon.Handle	:= Self.Icon.Handle;
			end;

			bitmap	:= TBitmap.Create;
			bitmap.Width	:= 32;
			bitmap.Height	:= 32;

			bitmap.Canvas.Draw(0, 0, icon);
			(Control as TListBox).Items.Objects[Index]	:= bitmap;
		finally
			icon.Free;
		end;
	end;
	if bitmap <> nil then begin
		// Bitmap darstellen
		(Control as TListBox).Canvas.CopyMode	:= copyMode;
		(Control as TListBox).Canvas.BrushCopy(Bounds(Rect.Left + gap, Rect.Top, Bitmap.Width, Bitmap.Height)
				, Bitmap, Bounds(0, 0, Bitmap.Width, Bitmap.Height), transparentColor);
		// Vier Pixel zwischen Text und Bitmap hinzufgen
		gap := bitmap.width + gap + 4;
	end;
	(Control as TListBox).Canvas.TextOut(Rect.Left + gap, Rect.Top + (Rect.Bottom - Rect.Top - (Control as TListBox).Canvas.Font.Size) div 2, (Control as TListBox).Items[Index])	{ Text anzeigen }
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
var
	i			: Integer;
begin
	try
		for i := 0 to lbAvailableKnownCPLs.Items.Count - 1 do begin
			if lbAvailableKnownCPLs.Items.Objects[i] <> nil then begin
				lbAvailableKnownCPLs.Items.Objects[i].Free;
			end;
		end;
	except
	end;
end;

procedure TfrmMain.lbAvailableKnownCPLsMeasureItem(Control: TWinControl;
  Index: Integer; var Height: Integer);
begin
	Height	:= 34;
end;

end.

